/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pb138.fsmda.analysis;

import cz.muni.fi.pb138.fsmda.common.ValidationException;
import java.io.File;
import java.io.IOException;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.xpath.XPathExpressionException;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;

/**
 *
 * @author Adriana Smijakova
 */
public interface DomManager {
    
    /**
     * Adds new directory element to the document attribute of the class
     * @param file file representing real file on HDD. Its parametres are added into the document 
     * @param path string which makes easier adding file into the document
     * @throws XPathExpressionException
     * @throws IOException
     * @throws InterruptedException
     * @throws SAXException 
     */
    
    //void addElement(File file, String path) throws XPathExpressionException, IOException, InterruptedException, SAXException;
    
    /**
     * 
     * @return Document attribute
     */
    
   // Document getDom();
    
    /**
     * Creates xml file on HDD from document attribute in class and put the xml file into the history folder
     * @throws TransformerConfigurationException
     * @throws TransformerException 
     */
    
    void createXML(Document document) throws TransformerConfigurationException, TransformerException;
    
    /**
     * Validates and creates Document from xml file
     * @param path string representing path to the xml file
     * @return Document from xml file if xml file is valid by schema.xsd
     * @throws SAXException
     * @throws IOException
     * @throws ParserConfigurationException 
     */
    
    Document domFromXML(String path) throws SAXException, IOException, ParserConfigurationException;
    
    /**
     * Validates document by schema.xsd
     * @param document Document which is validating
     */
    
    void validation(Document document);

}
