package cz.muni.fi.pb138.fsmda.analysis;

import org.w3c.dom.Document;



/**
 *
 * @author Maros Klimovsky
 */

/**
 * Interface representing Analysis of file system
 * 
 */
public interface FileSystemAnalyser {
  
  /**
     * Method analyzes given file system starting from given rootPath.
     * Root directory itself is not included and is represented only as <fileSystem> element
     * After successful analysis it creates DOM document with result
     * 
     * @param rootPath - path to root directory of file system on disc
     * @return Document containing XML representation of file system
     */
  Document analyseFileSystem(String rootPath);
  
  /**
     * Method analyzes given file system starting from given rootPath.
     * Root directory itself is not included and is represented only as <fileSystem> element
     * After successful analysis it creates XML file with result
     * 
     * @param rootPath - path to root directory of file system on disc
     */
  void analyseFileSystemAndStore(String rootPath);
 
}
