package cz.muni.fi.pb138.fsmda.comparison;

import java.util.List;
import org.w3c.dom.Document;

/**
 * FileSystemComparer compares two documents representing file systems and finds
 * all the differencies - in structure and in attributes of corresponding
 * records.
 *
 * @author Matus Nemec
 */
public interface FileSystemComparer {

    /**
     * Compares two valid documents representing the file systems. The control
     * document is a template and the test document is the one in which it is
     * looked for differencies.
     *
     * @param controlDoc valid document representing filesystem, used as a
     * template for comparison (created from xml stored on disk)
     * @param testDoc valid document representing filesystem, tested by the
     * comparison (created by analysis)
     * @return list of differences with description
     */
    List<String> compareFileSystemRepresentations(Document controlDoc, Document testDoc);
}
