/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pb138.fsmda.gui;

import java.util.List;
import javax.swing.JFrame;
import javax.swing.SwingUtilities;

/**
 * Dialog window with huge text area which contains list of differences gotten from comparation.
 * 
 * @author Radike
 */
public class ResultOfComparationDialog extends javax.swing.JDialog {

    /**
     * Creates new form ResultOfComparationDialog
     */
    public ResultOfComparationDialog(JFrame parent, 
            final String mainFolderPath,final String xmlFilePath, final List<String> listOfDifferences) {
        super(parent, true);
        initComponents();
        SwingUtilities.invokeLater(new Runnable() {
            @Override
            public void run() {
                textArea.setText("");
                int i =0;
                for (String difference : listOfDifferences) {
                    if(i>0)
                        textArea.append("\n");
                    textArea.append(difference);
                    i++;
                }
                mainFolderLabel.setText(mainFolderPath);
                mainFolderLabel.setToolTipText(mainFolderPath);
                xmlFileLabel.setText(xmlFilePath);
                xmlFileLabel.setToolTipText(xmlFilePath);
                setVisible(true);
            }
        });

    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        dialogInfoLabel = new javax.swing.JLabel();
        tableInfoLabel = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        textArea = new javax.swing.JTextArea();
        mainFolderLabel = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        xmlFileLabel = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Result of comparison");
        setAlwaysOnTop(true);
        setModalityType(java.awt.Dialog.ModalityType.APPLICATION_MODAL);
        setName("Result of comparation");

        dialogInfoLabel.setForeground(new java.awt.Color(255, 0, 0));
        dialogInfoLabel.setText("Current state of selected folder is NOT equal to selected xml file");

        tableInfoLabel.setText("Differences between them:");

        textArea.setColumns(20);
        textArea.setEditable(false);
        textArea.setRows(5);
        jScrollPane1.setViewportView(textArea);

        mainFolderLabel.setForeground(new java.awt.Color(0, 51, 255));
        mainFolderLabel.setText("<folder name>");
        mainFolderLabel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel1.setText("compared to");

        xmlFileLabel.setForeground(new java.awt.Color(102, 204, 0));
        xmlFileLabel.setText("<xml file name>");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1)
                    .addComponent(mainFolderLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(dialogInfoLabel)
                            .addComponent(tableInfoLabel)
                            .addComponent(jLabel1)
                            .addComponent(xmlFileLabel))
                        .addGap(0, 473, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(dialogInfoLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(mainFolderLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(xmlFileLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(tableInfoLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 478, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    /**
     * public static void main(String args[]) {
     * java.awt.EventQueue.invokeLater(new Runnable() {
     *
     * public void run() { ResultOfComparationDialog dialog = new
     * ResultOfComparationDialog(new javax.swing.JFrame(), true);
     * dialog.addWindowListener(new java.awt.event.WindowAdapter() {
     *
     *  public void windowClosing(java.awt.event.WindowEvent e) {
     * System.exit(0); } }); dialog.setVisible(true); } }); }
    *
     */
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel dialogInfoLabel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel mainFolderLabel;
    private javax.swing.JLabel tableInfoLabel;
    private javax.swing.JTextArea textArea;
    private javax.swing.JLabel xmlFileLabel;
    // End of variables declaration//GEN-END:variables
}
